package edu.udo.cs.uschi;

import edu.udo.cs.uschi.MyBeta;

public class BetaScaler
{
    protected MyBeta b_testset;
    protected MyBeta b_membership;

    public BetaScaler()
	throws Exception
    {
	b_testset = new MyBeta();
	b_membership = new MyBeta();
    };


    public BetaScaler(double[] params)
	throws Exception
    {
	b_testset = new MyBeta();
	b_membership = new MyBeta();
	setParameters(params[0],params[1],params[2],params[3]);
    };


    public BetaScaler(double t_p, double t_N, double m_p, double m_N)
	throws Exception
    {
	b_testset = new MyBeta();
	b_membership = new MyBeta();
	setParameters(t_p,t_N,m_p,m_N);
    };


    public void setParameters(double t_p, double t_N, double m_p, double m_N)
	throws Exception
    {
	b_testset.setPN(t_p,t_N);
	b_membership.setPN(m_p,m_N);
    };



    public void setParameters(double[] params)
	throws Exception
    {
	setParameters(params[0],params[1],params[2],params[3]);
    };


    public void setTestsetParams(double t_p, double t_N)
	throws Exception
    {
	b_testset.setPN(t_p,t_N);
    };


    public void setMembershipParams(double m_p, double m_N)
	throws Exception
    {
	b_membership.setPN(m_p,m_N);
    };


    public double[] getParameters()
    {
	double[] params = new double[4];
	params[0] = b_testset.p;
	params[1] = b_testset.N;
	params[2] = b_membership.p;
	params[3] = b_membership.N;
	return params;
    };


    public double scale(double unscaled_value)
	throws Exception
    {
	return b_testset.inverseDistributionFunction(b_membership.distributionFunction(unscaled_value));
    };

    public String toString()
    {
	String s;
	s = Double.toString(b_testset.p);
	s += " ";
	s += Double.toString(b_testset.N);
	s += " ";
	s += Double.toString(b_membership.p);
	s += " ";
	s += Double.toString(b_membership.N);
	return s;
    };
};
