package edu.udo.cs.uschi.scaler;

import edu.udo.cs.uschi.MembershipObject;
import edu.udo.cs.uschi.MembershipVector;
import edu.udo.cs.uschi.scaler.TrivialScaler;
import java.util.Properties;
import java.io.*;

public class SoftmaxScaler extends TrivialScaler
{

    public SoftmaxScaler()
    {
    };


    public SoftmaxScaler(Properties p)
    {
	parameters = p;
    };


    public void init(MembershipVector memberships)
    {
    };


    public MembershipObject scale(MembershipObject unscaled)
    {
	double[] m = unscaled.memberships;
	double[] n = new double[m.length];
	double sum=0;
	for(int i=0;i<m.length;i++){
	    n[i] = Math.exp(m[i]);
	    sum += n[i];
	};
	for(int i=0;i<m.length;i++){
	    n[i] /= sum;
	};
	MembershipObject scaled = new MembershipObject(unscaled.trueclass,n);
	return scaled;
    };


    public void write(BufferedWriter outfile)
	throws Exception
    {
	outfile.write("# SoftmaxScaler");
	outfile.newLine();
    };
};
