package edu.udo.cs.uschi.scaler;

import edu.udo.cs.uschi.MembershipObject;
import edu.udo.cs.uschi.MembershipVector;
import java.util.Properties;
import java.io.*;

public class TrivialScaler
{    
    Properties parameters;

    public TrivialScaler()
    {
    };


    public TrivialScaler(Properties p)
    {
	parameters = p;
    };


    public void init(MembershipVector memberships)
	throws Exception
    {
	// just check for examples in simplex
	MembershipObject toscale;
	double[] m;
	double precision = Double.parseDouble(parameters.getProperty("precision"));
	int i=memberships.size();
	int j;
	double sum;
	while(i>0){
	    i--;
	    toscale = (MembershipObject)(memberships.elementAt(i));
	    m = toscale.memberships;
	    sum=0;
	    j = m.length;
	    while(j>0){
		j--;
		sum += m[j];
		if(m[j] < 0){
		    throw(new Exception("Membership values must be non-negative. i = "+i+", m["+j+"] = "+m[j]));
		};
	    };
	    if(Math.abs(sum-1.0) > 1e-3){
		throw(new Exception("Membership values must sum up to 1."));
	    };
	};
    };


    public MembershipObject scale(MembershipObject unscaled)
    {
	// here: no scaling
	return unscaled;
    };


    public void scale(MembershipVector toScale)
    {
	MembershipObject scaled;
	int i=toScale.size();
	while(i>0){
	    i--;
	    scaled = scale((MembershipObject)(toScale.elementAt(i)));
	    toScale.setElementAt(scaled,i);
	};
    };


    public void read(BufferedReader infile)
	throws Exception
    {
    };


    public void write(BufferedWriter outfile)
	throws Exception
    {
	outfile.write("# TrivialScaler");
	outfile.newLine();
    };
};
